// Slade 3 find nearest color in palette, given RGB color.

short Palette8bit::nearestColour(rgba_t colour)
{
	int min_d = 999999;
	short index = 0;

	int d_r, d_g, d_b, diff;
	// for each color in the palette...
	for (short a = 0; a < 256; a++)
    {
        // calculate difference in red, green, blue
		d_r = colour.r - colours[a].r;
		d_g = colour.g - colours[a].g;
		d_b = colour.b - colours[a].b;

		// diff = difference in r^2 + difference in g^2 + difference in b*2
		diff = (d_r*d_r)+(d_g*d_g)+(d_b*d_b);

		// Exact match?
		if (diff == 0)
			return a; // return the index immediately if there is an exact match.
		else if (diff < min_d)
        {
			min_d = diff;
			index = a;
			// if it's not an exact match but the current index's color is a better match
			// than what we've seen so far, store it and continue.
		}
	}

	return index;
}
